/*
 ķ
   Program..: NUMPAD.PRG                            
   Author...: Roger J. Donnay                       
   Date.....: Dec  4, 2000                          
 Ľ
*/

#include 'inkey.ch'
#include 'dccolor.ch'
#include 'appevent.ch'
#include 'gra.ch'
#include 'xbp.ch'
#include 'dcmsg.ch'
#include 'dcdialog.ch'
#define COLOR_RED        GraMakeRGBColor( { 255,   0,   0 } )
#define COLOR_DARKRED    GraMakeRGBColor( { 127,   0,   0 } )
#define COLOR_GREEN      GraMakeRGBColor( {   0, 255,   0 } )
#define COLOR_DARKGREEN  GraMakeRGBColor( {   0, 127,   0 } )
#define COLOR_BLUE       GraMakeRGBColor( {   0,   0, 255 } )
#define COLOR_DARKBLUE   GraMakeRGBColor( {   0,   0, 127 } )
#define COLOR_CYAN       GraMakeRGBColor( {   0, 255, 255 } )
#define COLOR_DARKCYAN   GraMakeRGBColor( {   0, 127, 127 } )
#define COLOR_YELLOW     GraMakeRGBColor( { 255, 255,   0 } )
#define COLOR_BROWN      GraMakeRGBColor( { 127, 127,   0 } )
#define COLOR_PINK       GraMakeRGBColor( { 255,   0, 255 } )
#define COLOR_DARKPINK   GraMakeRGBColor( { 127,   0, 127 } )
#define COLOR_WHITE      GraMakeRGBColor( { 255, 255, 255 } )
#define COLOR_BLACK      GraMakeRGBColor( {   0,   0,   0 } )
#define COLOR_PALEGRAY   GraMakeRGBColor( { 192, 192, 192 } )
#define COLOR_DARKGRAY   GraMakeRGBColor( { 127, 127, 127 } )
#define COLOR_ORANGE     GraMakeRGBColor( { 253, 120,  41 } )
#define COLOR_LTORANGE   GraMakeRGBColor( { 250, 205,   0 } )
#define COLOR_LTBLUE     GraMakeRGBColor( {  30, 187, 255 } )
#define COLOR_LTYELLOW   GraMakeRGBColor( { 128, 128,   0 } )
#define COLOR_DKYELLOW   GraMakeRGBColor( { 212, 212,   0 } )
#define COLOR_DKBROWN    GraMakeRGBColor( {  72,  72,   0 } )
#define COLOR_SLATEGRAY  GraMakeRGBColor( { 158, 182, 205 } )
#define COLOR_SILVER     GraMakeRGBColor( { 192, 192, 192 } )
#define COLOR_ICEGREEN   GraMakeRGBColor( { 222, 255, 189 } )


FUNCTION PopNumPad( nValue )

LOCAL GetList := {}, GetOptions, nSaveValue, oCancelButton, nMaxWidth, nMaxHeight

_WindowWidthHeight( , , , , , , , , , , , , , , , ,@nMaxWidth, @nMaxHeight  )

PRIVATE lFirstTime := .t.

DEFAULT nValue := 0

oConfig1 := DC_XbpPushButtonXPConfig():new()
oConfig1:fgColorMouse    := COLOR_DARKGREEN
oConfig1:bgColorMouse    := COLOR_ORANGE
oConfig1:fgColor         := COLOR_DARKGREEN
oConfig1:bgColor         := COLOR_DARKGREEN
oConfig1:fgColorSelected := GRA_CLR_GREEN
oConfig1:bgColorSelected := COLOR_ICEGREEN
oConfig1:fgColorClick    := COLOR_DARKGREEN
oConfig1:bgColorClick    := COLOR_ICEGREEN
oConfig1:gradientStep    := 10
oConfig1:gradientReverse := .T.
oConfig1:radius          := 12
oConfig1:outline         := .T.
oConfig1:font            := '16.Arial Bold'
oConfig1:mouseOverFont   := '16.Arial Bold'
oConfig1:mouseOverScale  := 1.1
oConfig1:bitmapOffset    := 15
oConfig1:bitmapScale     := 1
oConfig1:alignBitmap     := XBPALIGN_HCENTER +XBPALIGN_VCENTER
oConfig1:borderColor     := GRA_CLR_YELLOW

nSaveValue := nValue

IF nValue = 0
  cValue := ''
ELSE
  cValue := Alltrim(Str(nValue))
	cValue := PadL(cValue,16)
ENDIF

@ -10,   0 DCGET cValue FONT '20.Courier New Bold' SIZE 290,60 PIXEL ;
   EDITPROTECT {||.t.} ID 'ACCUM'  ;
			RESIZE DCGUI_RESIZE_AUTORESIZE_SCALEFONT

@  50,  0 DCPUSHBUTTON ;
      CAPTION 2107 ;
      FONT '16.Arial Bold' ;
	    SIZE 80,80 ;
			PIXEL ;
    	ACTION {||Accum(7,@cValue,GetList)} ;
    	ACCELKEY Asc('7') ;
    	EVAL _FlashBlock(2107,2207) ;
			CONFIG oConfig1  ;
			RESIZE DCGUI_RESIZE_AUTORESIZE_SCALEFONT

@  50, 90 DCPUSHBUTTON CAPTION 2108 FONT '16.Arial Bold' SIZE 80,80 PIXEL ;
   ACTION {||Accum(8,@cValue,GetList)} ;
   ACCELKEY Asc('8') ;
   EVAL _FlashBlock(2108,2208) CONFIG oConfig1 ;
			RESIZE DCGUI_RESIZE_AUTORESIZE_SCALEFONT

@  50,180 DCPUSHBUTTON CAPTION 2109 FONT '16.Arial Bold' SIZE 80,80 PIXEL ;
   ACTION {||Accum(9,@cValue,GetList)} ;
   ACCELKEY Asc('9') ;
   EVAL _FlashBlock(2109,2209)CONFIG oConfig1 ;
			RESIZE DCGUI_RESIZE_AUTORESIZE_SCALEFONT

@ 130,  0 DCPUSHBUTTON CAPTION 2104 FONT '16.Arial Bold' SIZE 80,80 PIXEL ;
   ACTION {||Accum(4,@cValue,GetList)} ;
   ACCELKEY Asc('4') ;
   EVAL _FlashBlock(2104,2204) CONFIG oConfig1;
			RESIZE DCGUI_RESIZE_AUTORESIZE_SCALEFONT

@ 130, 90 DCPUSHBUTTON CAPTION 2105 FONT '16.Arial Bold' SIZE 80,80 PIXEL ;
   ACTION {||Accum(5,@cValue,GetList)} ;
   ACCELKEY Asc('5') ;
   EVAL _FlashBlock(2105,2205) CONFIG oConfig1 ;
			RESIZE DCGUI_RESIZE_AUTORESIZE_SCALEFONT

@ 130,180 DCPUSHBUTTON CAPTION 2106 FONT '16.Arial Bold' SIZE 80,80 PIXEL ;
   ACTION {||Accum(6,@cValue,GetList)} ;
   ACCELKEY Asc('6') ;
   EVAL _FlashBlock(2106,2206) CONFIG oConfig1 ;
			RESIZE DCGUI_RESIZE_AUTORESIZE_SCALEFONT

@ 200,  0 DCPUSHBUTTON CAPTION 2101 FONT '16.Arial Bold' SIZE 80,80 PIXEL ;
   ACTION {||Accum(1,@cValue,GetList)} ;
   ACCELKEY Asc('1') ;
   EVAL _FlashBlock(2101,2201) CONFIG oConfig1 ;
			RESIZE DCGUI_RESIZE_AUTORESIZE_SCALEFONT

@ 200, 90 DCPUSHBUTTON CAPTION 2102 FONT '16.Arial Bold' SIZE 80,80 PIXEL ;
   ACTION {||Accum(2,@cValue,GetList)} ;
   ACCELKEY Asc('2') ;
   EVAL _FlashBlock(2102,2202) CONFIG oConfig1 ;
			RESIZE DCGUI_RESIZE_AUTORESIZE_SCALEFONT

@ 200,180 DCPUSHBUTTON CAPTION 2103 FONT '16.Arial Bold' SIZE 80,80 PIXEL ;
   ACTION {||Accum(3,@cValue,GetList)} ;
   ACCELKEY Asc('3') ;
   EVAL _FlashBlock(2103,2203)  CONFIG oConfig1 ;
			RESIZE DCGUI_RESIZE_AUTORESIZE_SCALEFONT

@ 290,  0 DCPUSHBUTTON CAPTION 2100 FONT '16.Arial Bold' SIZE 80,80 PIXEL ;
   ACTION{||Accum(0,@cValue,GetList)} ;
   ACCELKEY Asc('0') ;
   EVAL _FlashBlock(2100,2200) CONFIG oConfig1  ;
			RESIZE DCGUI_RESIZE_AUTORESIZE_SCALEFONT

@ 290, 90 DCPUSHBUTTON CAPTION 2110 FONT '16.Arial Bold' SIZE 80,80 PIXEL ;
   ACTION {||Accum(10,@cValue,GetList)} ;
   ACCELKEY 46 ;
   EVAL _FlashBlock(2110,2210) CONFIG oConfig1  ;
			RESIZE DCGUI_RESIZE_AUTORESIZE_SCALEFONT

@ 290,180 DCPUSHBUTTON CAPTION 2112 FONT '16.Arial Bold' SIZE 80,80 PIXEL ;
   ACTION {||Accum(11,@cValue,GetList)} ;
   ACCELKEY 45 ;
   EVAL _FlashBlock(2112,2212) CONFIG oConfig1  ;
			RESIZE DCGUI_RESIZE_AUTORESIZE_SCALEFONT

@ 380,  0 DCPUSHBUTTON CAPTION 2111 FONT '16.Arial Bold' SIZE 100,80 PIXEL ;
   ACTION {||Accum(12,@cValue,GetList)} ;
   ACCELKEY { 67, 99 } ;
   EVAL _FlashBlock(2111,2211) CONFIG oConfig1 ;
			RESIZE DCGUI_RESIZE_AUTORESIZE_SCALEFONT

@ 380,120 DCPUSHBUTTON CAPTION 2113 FONT '16.Arial Bold' SIZE 100,80 PIXEL ;
   ACTION {||Accum(13,@cValue,GetList)} ;
   ACCELKEY 8 ;
   EVAL _FlashBlock(2113,2213) CONFIG oConfig1  ;
			RESIZE DCGUI_RESIZE_AUTORESIZE_SCALEFONT

@ 150,270 DCPUSHBUTTON CAPTION 2114 FONT '12.Arial Bold' SIZE 100,80 PIXEL ;
   ACCELKEY 13 ;
   ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)} CONFIG oConfig1 ;
			RESIZE DCGUI_RESIZE_AUTORESIZE_SCALEFONT

@ 240,270 DCPUSHBUTTON CAPTION 2115 FONT '12.Arial Bold' SIZE 100,80 PIXEL ;
   ACTION {||lReturn := .f., DC_ReadGuiEvent(DCGUI_EXIT_ABORT,GetList)} ;
   ACCELKEY 27 ;
   OBJECT oCancelButton CONFIG oConfig1 ;
			RESIZE DCGUI_RESIZE_AUTORESIZE_SCALEFONT

DCGETOPTIONS ;
   RESIZE ;
	 COLOR GRA_CLR_DARKBLUE

DCREAD GUI ;
   FIT ;
	 MODAL ;
   TITLE 'Numeric Pad' ;
   SETFOCUS @oCancelButton ;
   TO lStatus ;
   OPTIONS GetOptions;
	 EVAL {|O| MaximizeScreen(o, nMaxWidth, nMaxHeight) }

IF !lStatus
  nValue := nSaveValue
ELSE
  nValue := Val(cValue)
ENDIF

RETURN nValue

* ----------------

STATIC FUNCTION Accum ( nKey, cValue, GetList )

IF lFirstTime
  cValue := ''
ELSE
  cValue := Alltrim(cValue)
ENDIF

lFirstTime := .f.

IF nKey >= 0 .AND. nKey <= 9

  cValue += Alltrim(Str(nKey))

ELSEIF nKey == 10 // Decimal key

  cValue := StrTran(cValue,'.','')
  cValue += '.'

ELSEIF nKey == 11 // Minus Key

  IF Left(cValue,1) == '-'
    cValue := Substr(cValue,2)
  ELSE
    cValue := '-' + cValue
  ENDIF

ELSEIF nKey == 12 // Clear

  cValue := ''

ELSEIF nKey == 13 // Backspace

  cValue := Substr(cValue,1,Len(cValue)-1)

ENDIF

cValue := PadL(cValue,16)

DC_GetRefresh(GetList,'ACCUM')

RETURN nil

* ----------------

STATIC FUNCTION _FlashBlock( n1, n2 )

RETURN {|o|o:lbdown := {|a,b,x|_FlashBlock2(x,n1,n2)}}

* ----------------

STATIC FUNCTION _FlashBlock2( oXbp, n1, n2 )

_Flash( oXbp, n1, n2 )

RETURN nil

* -----------

STATIC FUNCTION _Flash( oButton, cCaption1, cCaption2 )

oButton:setFontCompoundName('12.Arial Bold')
oButton:setCaption(cCaption2)
Sleep(5)
oButton:setFontCompoundName('16.Arial Bold')
oButton:setCaption(cCaption1)
Sleep(5)
oButton:setFontCompoundName('12.Arial Bold')
oButton:setCaption(cCaption2)
Sleep(5)
oButton:setFontCompoundName('16.Arial Bold')
oButton:setCaption(cCaption1)
Sleep(5)

RETURN nil

FUNCTION MaximizeScreen( oDlg, nMaxWidth, nMaxHeight )

LOCAL aWorkArea, nRow, nCol , nWidth, nHeight

nWidth := oDlg:currentSize()[1]
nHeight := oDlg:currentSize()[2]

aWorkArea := DC_GetWorkArea()
nHeight := aWorkArea[4] - aWorkArea[2]
nWidth  := aWorkArea[3] - aWorkArea[1]

IF !Empty( nMaxWidth )
  nWidth := nMaxWidth
ENDIF

IF !Empty( nMaxHeight )
  nHeight := nMaxHeight
ENDIF

nCol := aWorkArea[1]
nRow := oDlg:setParent():currentSize()[2] - aWorkArea[4]
oDlg:setPos({nCol,nRow})
oDlg:setSize({nWidth,nHeight})

DC_CompleteEvents()

RETURN nil

FUNCTION _WindowWidthHeight( nWindowWidth, nWindowHeight, cSayFont, cGetFont, nColPixels,;
      nRowPixels , cHeadTitle, cSubTitle, nGetHeight, nBrowsNameWidth, cBrowsFont,;
      nSayHeight, nBrowsRowHeight, nGetStuIDWidth, nGetLunIdWidth, nGetFamIDWidth )

   LOCAL nWidth, nHeight

	 // default every parameter so any single field can be retrived without all of them
	 DEFAULT nWindowWidth   := 640 ,;
	         nWindowHeight  := 500 ,;
					 cSayFont       := '12.Times New Roman Bold' ,;
					 cGetFont       := '12.Times New Roman Bold' ,;
					 nColPixels     := 7  ,;
           nRowPixels     := 20 ,;
					 cHeadTitle     := '14.Times New Roman Bold'  ,;
					 cSubTitle      := '13.Times New Roman Bold'  ,;
					 nGetHeight     := 1.2                        ,;
					 nBrowsNameWidth  := 16                       ,;
					 cBrowsFont     := '13.Times New Roman Bold'  ,;
           nSayHeight     := 1.2   ,;
					 nBrowsRowHeight := 16   ,;
					 nGetStuIDWidth  := 10   ,;
					 nGetLunIdWidth  := 8    ,;
					 nGetFamIDWidth  := 10

   nWidth := AppDeskTop():currentSize()[1]
   nHeight := AppDeskTop():currentSize()[2]

	 IF nWidth < 800
      DCMSGBOX 'ALERT: Your window settings are set to low.',;
         'The minimum size your window should be set to is 800 x 600.',;
         'Please go to your Display Properties Setting tab and increase',;
         'the Screen size before running this program.'
   ENDIF


   IF nWidth <= 800
      nWindowWidth    := 640
      nWindowHeight   := 500
      nBrowsNameWidth := 16
      nGetStuIdWidth  := 10
      nGetLunIdWidth  := 8
      nGetFamIDWidth  := 10
      cSayFont   := '12.Times New Roman Bold'
      cGetFont   := '12.Times New Roman Bold'
      nGetHeight := 1.2
      nSayHeight := 1.2
      nBrowsRowHeight := 16
      cBrowsFont := '13.Times New Roman Bold'
      cSubTitle  := '13.Times New Roman Bold'
      cHeadTitle := '14.Times New Roman Bold'
      nColPixels := 7
      nRowPixels := 20
   ELSEIF nWidth <= 1024
      nGetHeight := 1.4
      nSayHeight := 1.6
      nGetStuIdWidth  := 19
      nGetLunIdWidth  := 6.8
      nGetFamIDWidth  := 8
      nWindowWidth  := 800
      nWindowHeight := 600
      cSayFont   := '14.Times New Roman Bold'
      cGetFont   := '14.Times New Roman Bold'
      nBrowsNameWidth := 17
      nBrowsRowHeight := 20
      cBrowsFont := '14.Times New Roman Bold'
      cSubTitle  := '14.Times New Roman Bold'
      cHeadTitle := '18.Times New Roman Bold'
      nColPixels := 8.5
      nRowPixels := 24
	 ELSEIF (nWidth == 1280) .AND. (nHeight == 800)
      nWindowWidth    := 1180
      nWindowHeight   := 600
      nBrowsNameWidth := 17
      nGetStuIdWidth  := 10
      nGetLunIdWidth  := 8
      nGetFamIDWidth  := 10
      cSayFont   := '12.Times New Roman Bold'
      cGetFont   := '12.Times New Roman Bold'
      nGetHeight := 1.4
      nSayHeight := 1.6
      nBrowsRowHeight := 20
      cBrowsFont := '13.Times New Roman Bold'
      cSubTitle  := '13.Times New Roman Bold'
      cHeadTitle := '14.Times New Roman Bold'
      nColPixels := 8.5
			nRowPixels := 24
	 ELSEIF nWidth <= 1280
      nGetHeight := 2
      nSayHeight := 2.25
      nGetStuIdWidth  := 19
      nGetLunIdWidth  := 6.8
      nGetFamIDWidth  := 9
      nWindowWidth := 1000
      nWindowHeight := 800
      nBrowsNameWidth := 18.8
      cSayFont   := '16.Times New Roman Bold'
      cGetFont   := '18.Times New Roman Bold'
      nBrowsRowHeight := 30
      cBrowsFont := '18.Times New Roman Bold'
      cSubTitle  := '20.Times New Roman Bold'
      cHeadTitle := '25.Times New Roman Bold'
      nColPixels := 10
      nRowPixels := 28
   ELSE
      nBrowsRowHeight := 35
      nGetHeight := 2.5
      nSayHeight := 2.5
      nGetStuIdWidth  := 19
      nGetLunIdWidth  := 7
      nGetFamIDWidth  := 9
      nWindowWidth := 1200
      nWindowHeight := 1000
      nBrowsNameWidth := 20
      cSayFont   := '18.Times New Roman Bold'
      cGetFont   := '18.Times New Roman Bold'
      cBrowsFont := '20E.Times New Roman Bold'
      cSubTitle  := '25.Times New Roman Bold'
      cHeadTitle := '30.Times New Roman Bold'
      nColPixels := 11.5
      nRowPixels := 32
   ENDIF
RETURN .T.



